


//------------------------------------------------------------------------------
//         Headers
//------------------------------------------------------------------------------

#include 	<board.h>
#include 	<pio/pio.h>
#include 	<aic/aic.h>
#include	<dbgu/dbgu.h>
#include 	<pwmc/pwmc.h>
#include	<utility/trace.h>
#include 	<mydef.h>
#include 	<pwmsinus.h>
//------------------------------------------------------------------------------

 

//------------------------------------------------------------------------------
//         local definitions
//------------------------------------------------------------------------------

#define PWM_FREQUENCY              	1	  //PWM Frequenz, bei CALG ON ist sie nur halb so gro
#define MAX_DUTY_CYCLE              1024
#define MIN_DUTY_CYCLE         		MAX_DUTY_CYCLE/2

//------------------------------------------------------------------------------


static const Pin pins[] = {
    PINS_DBGU,
    PIN_PWMC_PWM0,
    PIN_PWMC_PWM1,
	PIN_PWMC_PWM2
};

//------------------------------------------------------------------------------
//         Local functions
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
/// Wait time in ms
//------------------------------------------------------------------------------
void UTIL_Loop(unsigned int loop)
{
    while(loop--);	
}


void UTIL_WaitTimeInMs(unsigned int mck, unsigned int time_ms)
{
    register unsigned int i = 0;
    i = (mck / 1000) * time_ms;
    i = i / 3;
    UTIL_Loop(i);
}

//------------------------------------------------------------------------------
/// Wait time in us
//------------------------------------------------------------------------------
void UTIL_WaitTimeInUs(unsigned int mck, unsigned int time_us)
{
    volatile unsigned int i = 0;
    i = (mck / 1000000) * time_us;
    i = i / 3;
    UTIL_Loop(i);
}
//------------------------------------------------------------------------------
/// Interrupt handler for the PWM controller. Counts the number of periods and
/// updates the duty cycle after a given number.
//------------------------------------------------------------------------------




static void ISR_Pwmc(void)
{				  
	volatile static int i = MIN_DUTY_CYCLE;
	volatile unsigned int dummy;
	
	 while((AT91C_BASE_PWMC->PWMC_ISR & AT91C_PWMC_CHID0) == AT91C_PWMC_CHID0){ //Zurcksetzen des PWM IR 
			i=i+1;
			if ( i>= MAX_DUTY_CYCLE){
			i = MIN_DUTY_CYCLE;
			}
			
  			//PWMC_SetDutyCycle(CHANNEL_PWM_LED0, i);
			 AT91C_BASE_PWMC->PWMC_CH[CHANNEL_PWM_LED0].PWMC_CUPDR = i;	
		 	 	  
 		   }
}			




int main (void){

		PIO_Configure(pins, PIO_LISTSIZE(pins));
		UTIL_WaitTimeInUs(BOARD_MCK, 1000);

      	// Enable PWMC peripheral clock
    	AT91C_BASE_PMC->PMC_PCER = 1 << AT91C_ID_PWMC;  
		// Enable the Clock of the PIO
  		AT91C_BASE_PMC->PMC_PCER  = 1 << AT91C_ID_PIOA;	 

  		PWMC_ConfigureClocks(PWM_FREQUENCY * MAX_DUTY_CYCLE, 0, BOARD_MCK);
						 
		// Configurate PWM Channel 0
    	PWMC_ConfigureChannel(CHANNEL_PWM_LED0, AT91C_PWMC_CPRE_MCKA ,CALG_ON, 0);
    	PWMC_SetPeriod(CHANNEL_PWM_LED0, MAX_DUTY_CYCLE);
    	PWMC_SetDutyCycle(CHANNEL_PWM_LED0, MIN_DUTY_CYCLE);

		// Configurate PWM Channel 1
		PWMC_ConfigureChannel(CHANNEL_PWM_LED1, AT91C_PWMC_CPRE_MCKA, CALG_ON, 0);
    	PWMC_SetPeriod(CHANNEL_PWM_LED1, MAX_DUTY_CYCLE);
    	PWMC_SetDutyCycle(CHANNEL_PWM_LED1, MIN_DUTY_CYCLE);

		// Configurate PWM Channel 2
		//PWMC_ConfigureChannel(CHANNEL_PWM_LED2, AT91C_PWMC_CPRE_MCKA, AT91C_PWMC_CALG, 0);
    	//PWMC_SetPeriod(CHANNEL_PWM_LED2, MAX_DUTY_CYCLE);
    	//PWMC_SetDutyCycle(CHANNEL_PWM_LED2, MIN_DUTY_CYCLE);
																			
 
	 	//Configurate PWM interrrupt
	 	AIC_DisableIT(AT91C_ID_PWMC);
	 	AIC_ConfigureIT(AT91C_ID_PWMC, 0, ISR_Pwmc);
   	 	AIC_EnableIT(AT91C_ID_PWMC);


		UTIL_WaitTimeInUs(BOARD_MCK, 1000);

		//Enable the Interrupt
    	PWMC_EnableChannelIt(CHANNEL_PWM_LED0);
	//	PWMC_EnableChannelIt(CHANNEL_PWM_LED1);		
	//	PWMC_EnableChannelIt(CHANNEL_PWM_LED2);
		

		//Enable PWM Channel
		PWMC_EnableChannel(CHANNEL_PWM_LED0);
	//	PWMC_EnableChannel(CHANNEL_PWM_LED1);
	//	PWMC_EnableChannel(CHANNEL_PWM_LED2);
	//	AT91C_BASE_PWMC->PWMC_ENA = 0x07 ;	  		//	Enable Channel 1-3 
			
		AT91C_BASE_PIOA->PIO_PER  = 1<<4;
  		AT91C_BASE_PIOA->PIO_OER  = 1<<4;


				  
		while (1){	 
		  

				  
				  // AT91C_BASE_PIOA->PIO_CODR = 1<<4;
				  // UTIL_WaitTimeInMs(BOARD_MCK, 10);
				 //   AT91C_BASE_PIOA->PIO_SODR = 1<<4;
				 //UTIL_WaitTimeInMs(BOARD_MCK, 10);

		}		  


}
